Subject: Re: Is the manpage wrong for "ip address delete"?

From: Stephen Hemminger <[email-masked]>
Date: Thu, 25 Jul 2024 11:20:43 -0700

On Fri, 12 Jul 2024 11:33:45 +0100
Donald Hunter <[email-masked]> wrote:

> Adam Nielsen <[email-masked]> writes:
> 
> > Hi all,
> >
> > I'm trying to remove an IP address from an interface, without having to
> > specify it, but the behaviour doesn't seem to match the manpage.
> >
> > In the manpage for ip-address it states:
> >
> >     ip address delete - delete protocol address
> >        Arguments: coincide with the arguments of ip addr add.  The
> >        device name is a required  argument. The rest are optional.  If no
> >        arguments are given, the first address is deleted.

That part is just wrong. Went back and looked at really old system
running 2.4 kernel and it failed there as well. Probably something
that got changed long long ago, and no one cared or noticed.

> >
> > I can't work out how to trigger the "if no arguments are given" part:
> >
> >   $ ip address delete dev eth0
> >   RTNETLINK answers: Operation not supported
> >
> >   $ ip address delete "" dev eth0
> >   Error: any valid prefix is expected rather than "".
> >
> >   $ ip address dev eth0 delete
> >   Command "dev" is unknown, try "ip address help".
> >
> > In the end I worked out that "ip address flush dev eth0" did what I
> > wanted, but I'm just wondering whether the manpage needs to be updated
> > to reflect the current behaviour?  
> 
> Yes, that paragraph of the manpage appears to be wrong. It does not
> match the manpage synopsis, nor the usage from "ip address help" which
> both say:
> 
>   ip address del IFADDR dev IFNAME [ mngtmpaddr ]

ip address allows address before or after device name. 
Both are the same:
   # ip address delete 1.1.1.1/24 dev eth0
   # ip address delete dev eth0 1.1.1.1/24

> 
> The description does match the kernel behaviour for a given address
> family, which you can see by using ynl:

Kernel ynl is new and different.